unit rhsScaleBitmap;

{$mode objfpc}{$H+}

interface

uses
  Graphics, IntfGraphics, LazCanvas, FPCanvas;

procedure ScaleBitmap(BM: TCustomBitmap; Width, Height: Integer);

implementation

procedure ScaleBitmap(BM: TCustomBitmap; Width, Height: Integer);
var
  Source: TLazIntfImage = nil;
  Dest: TLazCanvas = nil;
begin
  try
    // Create the Source-LazIntfImage
    Source := BM.CreateIntfImage;
    // Create the Destination-LazCanvas
    Dest := TLazCanvas.Create(Source);
    // Execute the Canvas.StretchDraw
    Dest.StretchDraw(0, 0, Width, Height, Source);
    // Reload the stretched Source into the Bitmap
    BM.LoadFromIntfImage(Source);
    BM.SetSize(Width, Height);
  finally
    Dest.Free;
    Source.Free;
  end;
end;

end.
